<?php
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: updates.php 2034 2013-11-19 21:39:26Z jomann $

require_once(dirname(__FILE__).'/../includes/common.inc.php');


// initialization stuff
pre_init();

// start session
init_session();

// grab GET or POST variables 
grab_request_vars();

// check prereqs
check_prereqs();

// check authentication
check_authentication(false);


route_request();

function route_request(){
	global $request;
	global $lstr;
	
	$performupdate=grab_request_var("performupdate");
	
	if(is_admin()==false){
		echo $lstr['NotAuthorizedErrorText'];
		exit();
		}
	if(isset($request["performupdate"]))
		perform_update();
	else
		show_updates_page();
	
	exit();
	}
	
function perform_update(){

	// demo mode
	if(in_demo_mode()==true)
		show_updates_page(true,$lstr['DemoModeChangeError']);
	
	$id=submit_command(COMMAND_UPDATE_XI_TO_LATEST,$component_file);
		if($id<=0)
			show_updates_page(true,$lstr['ErrorSubmittingCommandText']);
		else{
			for($x=0;$x<40;$x++){
				$status_code=-1;
				$result_code=-1;
				$args=array(
					"cmd" => "getcommands",
					"command_id" => $id,
					);
				$xml=get_backend_xml_data($args);
				if($xml){
					if($xml->command[0]){
						$status_code=intval($xml->command[0]->status_code);
						$result_code=intval($xml->command[0]->result_code);
						$result_text=strval($xml->command[0]->result);
						}
					}
				if($status_code==2){
					if($result_code==0){
						// redirect to show install message (so the list will include the new component)
						header("Location: ?installedok");
						exit();
						}
					else{
						//print_r($xml);
						//echo "<BR>RESULT TEXT=$result_text<BR>";
						$emsg="";
						if($result_text!="")
							$emsg.=" ".$result_text."";
						show_updates_page(true,$lstr['ComponentInstallFailedText'].$emsg);
						//show_updates_page(true,"ERROR=".$emsg);
						}
					exit();
					}
				usleep(500000);
				}
			}
		show_updates_page(false,gettext('Nagios XI Upgrade Scheduled'));

}

function show_updates_page($error=false,$msg=""){
	global $lstr;
	
	$checknow=grab_request_var("checknow");
	
	if($checknow==1){
		check_nagios_session_protector();
		do_update_check(true);
		}

		
	do_page_start(array("page_title"=>$lstr['UpdatesPageTitle']),true);

?>

	<h1><?php echo $lstr['UpdatesPageHeader'];?></h1>
	
	<?php echo $lstr['UpdatesPageNotes'];?>

<?php
	display_message($error,false,$msg);
?>
	
<br clear="all">

<div style="float: left; margin-top: 25px; clear: left;">
	<div><form method="post" action="<?php echo htmlentities($_SERVER['PHP_SELF']);?>">
	<?php echo get_nagios_session_protector();?>
	<input type="hidden" name="checknow" value="1">
	<div id="formButtons">
	<input type="submit" class="submitbutton" name="updateButton" value="<?php echo $lstr['CheckForUpdatesButton'];?>" id="updateButton"> 
	</div>
	</form>
	</div>
<?php
		if (use_2014_features()) {
?>
	<div>
	<form method="post" action="<?php echo htmlentities($_SERVER['PHP_SELF']);?>">
	<?php echo get_nagios_session_protector();?>
	<input type="hidden" name="performupdate" value="1">
	<div id="formButtons">
	<input type="submit" class="submitbutton" name="performUpdateButton" value="<?php echo gettext('Upgrade to Latest');?>" id="performUpdateButton">
	</div>
	</form>
	</div>
<?php
	}
?>
</div>


<div style="float: left; margin-top: 25px; clear: left;">

<div>
<?php
	display_dashlet("xicore_available_updates","",null,DASHLET_MODE_OUTBOARD);
?>
</div>


</div><!--left float -->



<?php

	do_page_end(true);
	exit();
	}


?>

